#version 150

uniform sampler2D InSampler;
uniform float GameTime;
uniform vec2 ScreenSize;

in vec2 texCoord;
in vec2 oneTexel;

out vec4 fragColor;

void main() {
    vec4 texSample = texture(InSampler, texCoord);
    if (texSample.a > 0.0) {
        float t = (gl_FragCoord.x + gl_FragCoord.y + GameTime * 24000.0) / 16.0;
        float alpha = (sin(GameTime * 3600.0) * 0.5 + 0.5) + 0.01;
        fragColor = vec4(texSample.rgb, (fract(t) < 0.5 ? 0.40 : 0.55) * alpha);
        return;
    }

    fragColor = texSample;
}
